---
title: Overview
description: Introduction to LispPad and description of its features.
order: -.INF
---

## What is LispPad?

[LispPad](http://lisppad.objecthub.net) is a simple, lightweight, integrated development environment for
developing and running Scheme code on macOS. The [language supported by LispPad](5-1-features.html)
is based on the [R7RS (small) standard for Scheme](http://r7rs.org). LispPad provides the following components:

- A fully integrated Scheme interpreter (based on the [LispKit engine](https://github.com/objecthub/swift-lispkit))
- A console with a read-eval-print loop
- A text editor supporting syntax highlighting, smart indentation, parenthesis matching, page guides, etc.
- A large set of natively supported Scheme libraries

## Table of contents

1. [Sessions](1-sessions.html)
2. [Editing code](2-editing-code.html)
3. [Customizing preferences](3-customizing-prefs.html)
4. [Getting started with Scheme](4-getting-started.html)
5. [Language overview](5-1-features.html)
6. [Libraries](6-libraries.html)
7. [Examples](8-1-example.html)
8. [Release Notes](9-release-notes.html)
